using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace game
{
    /// <summary>
    /// La classe <c>BasicPlant</c> hrite de la classe parent <c>BasicItem</c>, elle reprsente la classe mre des graines et des plantes.
    /// Elle possde un attribut typePlante.
    /// </summary>
    public abstract class BasicPlant : BasicItem
    {
        protected EnumTypePlant typePlante;

        /// <summary>
        /// Le constructeur <c>BasicPlant</c> permet de crer une plante (ou une graine), de base c'est une plante (ou graine) de bl
        /// </summary>
        public BasicPlant(){
            typePlante = EnumTypePlant.ELB;
        }

        /// <summary>
        /// Le constructeur <c>BasicPlant</c> (avec un paramtre) permet de crer une plante (ou une graine)  partir d'un type de plante (ou de graine)
        /// </summary>
        /// <param name="paraTypePlant"></param>
        public BasicPlant(EnumTypePlant paraTypePlant){
            this.typePlante = paraTypePlant;
        }

        /// <summary>
        /// La mthode <c>getTypePlante</c> permet d'obtenir le type de la plante (ou de la graine)
        /// </summary>
        /// <returns>Elle retourne le type.</returns>
        public EnumTypePlant getTypePlante()
        {
            return typePlante;
        }
    }
}

