using System.Collections.Generic;
using UnityEngine;
using TMPro;
using game;

/// <summary>
/// La classe <c>DropDownMarket</c> permet d'afficher le graphe et les plantes.
/// Elle possde 4 attributs : dropdown, market, graphMarket, plTypeList.
/// </summary>
public class DropDownMarket : MonoBehaviour
{
    public TMP_Dropdown dropdown;

    public Market market;

    public GraphMarket graphMarket;

    private List<EnumTypePlant> plTypeList;

    /// <summary>
    /// La mthode <c>Start</c> est utilise pour le dmarrage. tant donn que Start n'est appele qu'une seule fois, elle permet d'initialiser les lments
    /// qui doivent persister tout au long de la vie du script, mais ne doivent tre configurs qu'immdiatement avant utilisation.
    /// Pour notre cas elle rcupre tout les type de plante, afin de pouvoir les afficher dans un dropdown
    /// </summary>
    void Start()
    {
        plTypeList = CreateAllSeedPlant.dicoPlant.getAllPlantType();
        List<Plant> plList = new List<Plant>();
        foreach (EnumTypePlant plType in plTypeList)
        {
            plList.Add(CreateAllSeedPlant.dicoPlant.createPlant(plType));
        }


        dropdown.ClearOptions();


        List<TMP_Dropdown.OptionData> plantItems = new List<TMP_Dropdown.OptionData>();

        foreach (Plant pl in plList)
        {
            TMP_Dropdown.OptionData plantItem = new TMP_Dropdown.OptionData("", pl.getSprite());
            plantItems.Add(plantItem);
        }
        dropdown.AddOptions(plantItems);
    }

    /// <summary>
    /// La mthode <c>updateGraph</c> permet de mettre  jour le graph
    /// </summary>
    /// <param name="newIndex">le nouveau point du graph</param>
    public void updateGraph(int newIndex)
    {
        graphMarket.changePlant(plTypeList[newIndex]);
    }
}